<!-- START doctoc generated TOC please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN doctoc TO UPDATE -->
**Table of Contents**  *generated with [DocToc](http://doctoc.herokuapp.com/)*

- [Contributing to Bare-Arduino-Project](#contributing-to-bare-arduino-project)
  - [Getting Started](#getting-started)
  - [Making Changes](#making-changes)
- [Additional Resources](#additional-resources)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

# Contributing to Bare-Arduino-Project

Community made patches, localizations, bug reports, documentation and contributions are always welcome and are crucial to the success of this project.

When contributing please ensure you follow the guidelines below so that we can keep on top of things.

## Getting Started

Submit a ticket for your issue, assuming one does not already exist.

*	Raise it on our [Issue Tracker](https://github.com/weareleka/bare-arduino-project/issues)
*	Clearly describe the issue including steps to reproduce the bug.
*	Make sure you fill in the earliest version that you know has the issue as well as the following
    *	Your operating system (Mac, Linux/Unix, Windows)
    *	Your Arduino IDE version
    *	Your board, sensors and actuators

## Making Changes

**First thing first**, read carefully our *`[rules and tools](https://github.com/WeAreLeka/rules-and-tools)`*.

Then:

*	Fork the repository on GitHub
*	Create a **new branch** for the current story you are working on. Using `master` is [bad practice](http://codeinthehole.com/writing/pull-requests-and-other-good-practices-for-teams-using-github/#work-on-a-story)
*	Make changes to your forked repository
*	If you are adding or changing the behavior of any variable, method or class, then update the corresponding documentation in the respective files as well
*	When committing, reference your issue (if present) and include a note about the fix
    *	If possible (and if it makes sense) do [atomic commits](http://en.wikipedia.org/wiki/Atomic_commit)
    *	Try to follow [this guideline](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html) while choosing the git commit message
*	Push the changes to your fork and submit a pull request to the `dev` branch of the this repository

At this point you're waiting for us to merge your pull request. We'll review all pull requests, and make suggestions and changes if necessary.

# Additional Resources

*	[Leka Rules & Tools](https://github.com/WeAreLeka/rules-and-tools)
*	[General GitHub Documentation](http://help.github.com/)
*	[GitHub Pull Request documentation](http://help.github.com/send-pull-requests/)
*	[Guide about contributing code in GitHub](http://sudarmuthu.com/blog/contributing-to-project-hosted-in-github)
